# Configure Rails Environment
ENV["RAILS_ENV"] = "test"

require File.expand_path("../dummy/config/environment.rb",  __FILE__)
require "rails/test_help"
require 'minitest/mock'

Rails.backtrace_cleaner.remove_silencers!

# Load support files
Dir["#{File.dirname(__FILE__)}/support/**/*.rb"].each { |f| require f }

# Load fixtures from the engine
if ActiveSupport::TestCase.method_defined?(:fixture_path=)
  ActiveSupport::TestCase.fixture_path = File.expand_path("../fixtures", __FILE__)
end

class Object
  def instance_stub name, val_or_callable, *block_args, &block
    new_name = "__minitest_stub__#{name}"

    if respond_to? name and not methods.map(&:to_s).include? name.to_s then
      self.send :define_method, name do |*args|
        super(*args)
      end
    end

    self.send :alias_method, new_name, name

    self.send :define_method, name do |*args, &blk|

      ret = if val_or_callable.respond_to? :call then
        val_or_callable.call(*args)
      else
        val_or_callable
      end

      blk.call(*block_args) if blk

      ret
    end

    yield self
  ensure
    self.send :undef_method, name
    self.send :alias_method, name, new_name
    self.send :undef_method, new_name
  end
end
